# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without mead

%if "%{?rhel}" == "6"
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif
%else
%bcond_with repolib
%endif

%define reltag .redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define section free

%define maven_version 1.1.3-redhat-2

Name:           jaxen
Version:        1.1.3
Release:        8%{?reltag}%{?dist}.4
Epoch:          0
Summary:        XPath engine written in Java
License:        BSD
URL:            http://jaxen.codehaus.org/
Group:          Development/Java

%if %with mead
Source100: jaxen-jaxen-1.1.3-redhat-2-sources.zip
Source101: jaxen-jaxen-1.1.3-redhat-2-patches.zip
Source102: jaxen-1.1.3-redhat-2.jar
Source103: jaxen-1.1.3-redhat-2.pom
Source104: jaxen-1.1.3-redhat-2-javadoc.jar
Source105: jaxen-1.1.3-redhat-2-sources.jar
%endif

%if %without mead
%if 0
#1357--1361
export TZ=America/Los_Angeles
svn -q export -r 1361 https://svn.codehaus.org/jaxen/trunk/jaxen jaxen-1.1.3 && tar cjf jaxen-1.1.3.tar.bz2 jaxen-1.1.3
Source0:        http://dist.codehaus.org/jaxen/distributions/jaxen-1.1.3-src.tar.gz
%endif
Source0:        jaxen-1.1.3.tar.bz2
%if 0
1364.
http://jira.codehaus.org/browse/JAXEN-149
%endif
Patch0:         jaxen-maven2.patch
Patch2:         jaxen-pom.patch
%endif
# XXX: should check against: http://repo1.maven.org/maven2/jaxen/jaxen/1.1.3/jaxen-1.1.3.pom
Obsoletes:      jaxen-bootstrap < %{epoch}:%{version}-%{release}
Provides:       jaxen-bootstrap = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jdom >= 0:1.0
Requires:       jpackage-utils
%if %without mead
BuildRequires:	cobertura-maven-plugin
BuildRequires:  java-devel
BuildRequires:  java-javadoc
BuildRequires:  jboss-parent
BuildRequires:	jdepend-maven-plugin
BuildRequires:  jpackage-utils
BuildRequires:  maven2
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-changes
BuildRequires:  maven2-plugin-changelog
BuildRequires:  maven2-plugin-checkstyle
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:	maven2-plugin-jxr
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-pmd
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-default-skin
BuildRequires:  dom4j >= 0:1.6.1
BuildRequires:	jakarta-commons-codec >= 0:1.4
BuildRequires:  jdom >= 0:1.1.2
BuildRequires:  xml-commons-jaxp-1.3-apis >= 0:1.3.04
BuildRequires:  xerces-j2 >= 0:2.9.1
BuildRequires:  xom >= 0:1.0
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Jaxen is an XPath engine written in Java to work against a variety of XML
based object models such as DOM, dom4j and JDOM together with Java
Beans.

OPTIONAL: If you want to use xom as the xpath implementation make sure
xom.jar (package 'xom') is in the classpath; other xpath implementations
can also be used like the one in the JDK.

%if %without mead
%package demo
Summary:        Samples for %{name}
Group:          Development/Documentation

Requires:       %{name} = %{epoch}:%{version}-%{release}

%description demo
%{summary}.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%package manual
Summary:        Documents for %{name}
Group:          Development/Documentation


%description manual
%{summary}.
%endif

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0
%patch2 -p1 -b .sav2
%endif

%build
%if %without mead
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file://`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate

prevversion=`%{_bindir}/find maven2-brew -type d \( -name '[0-9]*' -a -not -name %{namedversion} \) -print -quit`
[ -z "${prevversion}" ] || prevversion=`/bin/basename ${prevversion}` && for d in `%{_bindir}/find maven2-brew -type d -name ${prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|'${prevversion}'|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p maven2-brew/jaxen/jaxen/%{namedversion}/jaxen-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p maven2-brew/jaxen/jaxen/%{namedversion}/jaxen-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p maven2-brew/jaxen/jaxen/%{namedversion}/jaxen-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%else
%{__cp} -p %{_sourcedir}/%{name}-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%endif

# depmaps
%add_to_maven_depmap jaxen jaxen %{namedversion} JPP %{name}

%if %without mead
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/* %{buildroot}%{_docdir}/%{name}-%{namedversion}
%{__rm} -r %{buildroot}%{_docdir}/%{name}-%{namedversion}/apidocs

# demo
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}-%{namedversion}/samples
%{__cp} -pr src/java/samples/* %{buildroot}%{_datadir}/%{name}-%{namedversion}/samples
%endif

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%if %without mead
%doc LICENSE.txt
%endif
%{_javadir}*/%{name}-%{namedversion}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-%{namedversion}-sources.jar
%{_javadir}*/%{name}-sources.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%if %without mead
%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{namedversion}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{namedversion}
%endif

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.3-8.redhat_2.4
- Rebuild for MD5

* Sun Sep 02 2012 Paul Gier <pgier@redhat.com> - 0:1.1.3-7.redhat_2.4
- Fix encoding in pom.xml

* Fri Aug 17 2012 Vladimir Dosoudil <dosoudil@redhat.com> - 0:1.1.3-7.redhat_2.3
- Update poms for eap 6.0.1

* Mon Aug 13 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.3-6.redhat_2.3
- Rebuild unsigned

* Fri Aug 10 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.3-6.redhat_2.2
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.3-6.redhat_1.1
- Rebuild using cache signing

* Mon Jun 18 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.1.3-6.redhat_1
- Build in MEAD

* Thu Jun 14 2012 David Walluck <dwalluck@redhat.com> 0:1.1.3-5
- work around deploy bug
- update Group

* Mon Apr 23 2012 David Walluck <dwalluck@redhat.com> 0:1.1.3-4
- fix regression jdom:jdom -> org.jdom:jdom (resolves JBPAPP-8807)

* Wed Apr 18 2012 David Walluck <dwalluck@redhat.com> 0:1.1.3-3
- add `.' to reltag

* Tue Apr 17 2012 David Walluck <dwalluck@redhat.com> 0:1.1.3-2
- update pom

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> 0:1.1.3-1.redhat_1
- Rebuild for cached signing

* Sat Nov 12 2011 David Walluck <dwalluck@redhat.com> 0:1.1.3-0.2_redhat_1
- rebuild for deploy bug

* Fri Oct 28 2011 David Walluck <dwalluck@redhat.com> 0:1.1.3-0.1_redhat_1
- 1.1.3
- disable site (manual subpackage)

* Thu Apr 28 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-9
- use offline mvn-jpp, not mvn
- fix maven depmap
- fix dir ownership
- use backwards compatible maven BR

* Thu Apr 28 2011 Fernando Nasser <fnasser@redhat.com> - 0:1.1.2-8
- Make xom optional

* Thu Jan 20 2011 Hui Wang <huwang@redhat.com> - 0:1.1.2-7
- Rebuild

* Thu Nov 18 2010 Hui Wang <huwang@redhat.com> - 0:1.1.2-6
- Fix %%files for signed jars
- Add upload.sh and content of maven2-brew to repolib
- Fix license
- Fix pom file by sed command in repolib subpackage

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.2-5.1
- rebuilt

* Mon Apr 19 2010 Yiqiao Wang <yiwang@redhat.com> 0:1.1.2-5
- Rebuild

* Mon Aug 03 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-4
- fix pom syntax

* Mon Aug 03 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-3
- update maven pom to remove plugins

* Mon Aug 03 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-2
- add new pom
- remove saxpath depmap and symlink

* Wed Jul 29 2009 David Walluck <dwalluck@redhat.com> 0:1.1.2-1
- 1.1.2

* Fri Dec 21 2007 Ralph Apel <r.apel@r-apel.de> 0:1.1.1-1jpp
- 1.1.1
- Add pom and depmap frag

* Fri Nov 16 2007 Ralph Apel <r.apel@r-apel.de> 0:1.1-4jpp
- Provide saxpath legacy symlink

* Fri May 04 2007 Ralph Apel <r.apel@r-apel.de> 0:1.1-3jpp
- Fix project_xml.patch to meet depmap processing
- Add maven-plugin-checkstyle, -jxr, -linkcheck, -pmd BRs

* Wed Feb 21 2007 Ralph Apel <r.apel@r-apel.de> 0:1.1-2jpp
- Fix patches
- Add gcj_support option
- Drop echoing of options in prep

* Sat Feb 17 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.1-1jpp
- Upgrade to 1.1 final
- Updated xsl sheet
- Updated ant build file
- Removed un-necessary saxon transforms
- Fixed BuildRequires and Requires
- Fixed javadoc creation
- Added an option to not use sf plugins

* Sun Feb 26 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1-0.b7.4jpp
- Rebuild for JPP 1.7

* Wed Feb 15 2006 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.3jpp
- Insert Copyright notice

* Mon Feb 13 2006 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.2jpp
- Adapt to maven-1.1
- Create option to build without maven

* Wed Aug 17 2005 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b7.1jpp
- Upgrade to 1.1-beta-7
- Now mavenized
- Requiring dom4j >= 1.6.1
- rpmbuild option to inhibit build of manual (needs newer maven)

* Thu Sep 09 2004 Ralph Apel <r.apel@r-apel.de> 0:1.1-0.b2.1jpp
- Upgrade to 1.1-beta-2
- Drop saxpath requirement as saxpath is now included in jaxen

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-4jpp
- Rebuild with ant-1.6.2
* Mon Jan 19 2004 Ralph Apel <r.apel@r-apel.de> 0:1.0-3jpp
- build against dom4j-1.4-1jpp
- introduce manual and demo subpackages
- patch org.jaxen.dom4j.DocumentNavigatorTest
- include LICENSE in main package
- run tests during build

* Thu Jan 15 2004 Ralph Apel <r.apel@r-apel.de> 0:1.0-2jpp
- activate support for dom4j by renaming lib/dom4j-core.jar to .zip

* Sun May 04 2003 David Walluck <david@anti-microsoft.org> 0:1.0-1jpp
- release
